<html>
	<head>
		<title>Projet Groupe 36</title>
		<link rel="stylesheet" href="style.css" >
		
	</head>
	<body>
		<h1 style="text-align: center;">Jeu d'arcade !<br></h1>
		<a href="index.html">Retourner a la page principale<br></a>
		<center><img src="../Yvan/miniature.png" alt="Jeu d'arcade" width="700" height="400"  /></center>
		<p>Nous avons réalisé un jeu d'arcade en SDL2 qui utilise la notion de graphes.
		Le principe de notre jeu est de sauver un papillon qui est piégé dans la toile d'une araignée.
		<br><br><br>
		Pour ce faire le joueur peut choisir de couper un fil de la toile, mais l'araignée avance alors vers le papillon.
		<br><br><br>
		Si l'araignée atteint le papillon, le joueur a perdu, sinon il gagne un point.
		Il y a plusieurs niveaux que nous avons conçu et le jeu continue avec des niveaux générés aléatoirement.
		<br><br><br><br><br><br>

		</p>
		
		<center><img src="../Yvan/gif/arcade.gif" alt="Demo du jeu" width="900" height="500"  /></center>
		<U><h3>Un peu de code:<br></h3></U>
			<pre><code class="language-c">
	
				// Définition des structures utilisées dans le projet
		
				typedef struct sprite{
					int *textId;
					int nSprite;
					int spriteState;
					int x, y, w, h;
					int speed, angle;
					int isShowed;
				} sprite_t;

				typedef struct sdlMedia{
					SDL_Window *window;
					SDL_Renderer *renderer;
					TTF_Font *font;
					int nString;
					SDL_Texture **stringListe;
					SDL_Rect *stringPos;
					int nTexture;
					SDL_Texture **textureListe;
					int nSprite;
					sprite_t **spriteListe;
					
					int windowW, windowH;
					int animSpeed;
					int state;
					
				} sdlMedia_t;



				typedef struct spider{
					int iNoeud;
					int iNoeudPrec;
					int state;
					
					int currentSpriteId;
					int pasAnim;
					
					int spriteIdRepos;
					int spriteIdMvt;
				} spider_t;

				typedef struct papillon{
					int iNoeud;
					
					int currentSpriteId;
					
					int spriteRepos;
					
				} papillon_t;

				typedef struct noeud{
					int x;
					int y;
				} noeud_t;

				typedef struct level{
					int taille;
					int **matriceConnexion;
					noeud_t *listeNoeuds;
					spider_t *spider;
					papillon_t *papillon;
					
				} level_t;

				// gestion de la vitesse d'animation en gardant un jeu reactif

				while(program_on){
					SDL_RenderPresent(media->renderer);
					SDL_Delay(5);
					compteur = (compteur >= media->animSpeed)?0:compteur+1;
					if(compteur == 0){
						update(media, level);
					}
				}

				// detection du clique sur une arete


				int isMouseOnLine(int mx, int my, int xSrc, int ySrc,int xDst, int yDst){
					int pas = 16;
					int demiPas = 6;
					
					int norme = sqrt((yDst-ySrc)*(yDst-ySrc)+(xDst-xSrc)*(xDst-xSrc));
					int n = norme/pas;
					
					float dx = (xDst-xSrc)/n;
					float dy = (yDst-ySrc)/n;
					
					int r = 0;
					int i;
					for(i = 0; i < n; i++){
						if(contain(mx,my,xSrc+i*dx-demiPas, ySrc+i*dy-demiPas, pas, pas)) r = 1;

					}
					return r;
				}
		</code></pre>

		
		<U><h3>Nos niveaux:<br></h3></U>
		<img src="../Yvan/niveau0.png" alt="Niveau 0" width="800" height="500"  />
		<img src="../Yvan/niveau1.png" alt="Niveau 1" width="800" height="500"  />
		<img src="../Yvan/niveau2.png" alt="Niveau 2" width="800" height="500"  />
		
		
		<U><h3>Quelques idées:</h3></U>
		<p>Bien sûr, nous avons eu quelques idées pour continuer ce jeu, que nous n'avons pas pu implémenter par manque de temps.
		<br><br><br>
		 Nous aurions aimé ajouter des fils en métal, que le joueur ne peut pas casser, d'autres araignées pour augmenter la difficulté ou encore d'autres papillons à sauver. 
		<br><br><br>
		Nous aurions aussi aimé surligner le fil que le joueur s'apprête à couper. Il serait également bon de changer le système de sélection des arêtes qui est actuellement imparfait. Pour améliorer le code, il serait aussi bon de séparer proprement la boucle graphique et la boucle logique dans deux threads séparés.  
		 </p>
		 <a href="index.html">Retourner a la page principale<br></a>
	</body>
</html>
<pre><code class="language-c">
			
</code></pre>
